;++++++++++++++++++++++++++++++++++++++++++++++++++++
;+              BskV20_GroupR}h                +
;+ 2020-10-10:                                  +
;++++++++++++++++++++++++++++++++++++++++++++++++++++
;O[oϐ
(setq g_sAppname "SkkyGrpXdata")

;װ
(defun SKGrpCmd_err (s)
	; װ֐ɖ߂
	(setq *error* old_err)

	;IZbgJ
	(if g_sSet
		(sk_ssfree g_sSet)
	)
	(setq g_sSet nil)

	;ѕϐA
	(ModeReset)

	; ^үނ\
	(if *error* (progn
		(princ s)
		(*error* s)
	))
)

;1. O[v}`Ή̊_Rs[(COPYBASE)R}h
(defun c:Ask_CopyGrp ( / iLen i)
	;ss̊e}`XdataNA
	;AvP[V: sApp
	(defun GrpXdataClear (ss sApp / iLen i enItem)
		(setq iLen (sslength ss) i 0)
		(repeat iLen
			(setq enItem (ssname ss i))
			(RemoveXdt enItem sApp)
			(setq i (1+ i))
		)
	)


	;}`ɃO[v𖄂ߍ
	;(XdataAvP[V:"Skkya_GroupID")
	(defun EmbedGroupName (sStr enm / lst)
		;XdataXg
		(if (setq lst (GetXdtList enm g_sAppname))
			(setq lstXdata (append lst (list (cons 1000 sStr))))
		;else
			(setq lstXdata (list (cons 1000 sStr)))
		)

		;Xdata𖄂ߍ
		(RemoveXdt enm g_sAppname)
		(SetXdtLst enm g_sAppname lstXdata)
	)

	; װׯߊ֐̐ݒ
	(setq old_err *error*  *error* SKGrpCmd_err)
	(*push-error-using-command*)
	(ModeSet '("CMDECHO"))
	(setvar "CMDECHO" 0)

	(if (setq g_sSet (sk_pssget "\nNbv{[hɃRs[}`I: "))(progn
		(if (setq pOrg (getpoint "\n_w: "))(progn
			;g_sSet̊e}`XdataNA
			(GrpXdataClear g_sSet g_sAppname)

			;g_sSetɓO[v̐}`Xg(ARX)
			;XgC[W =
			;  (
			;    (sGroup1 (en11 en12 ...))
			;    (sGroup2 (en21 en22 ...))
			;    ...
			;    (sGroupX (enX1 enX2 ...))
			;  )
			(setq lstGrpEnam (sk_GrpEnamlistFrom g_sSet))

			;O[vɑĂe}`ɃO[v𖄂ߍ(gf[^)
			(setq iLen (length lstGrpEnam) i 0)
			(repeat iLen
				(setq lstItem (nth i lstGrpEnam))
				(setq sName (car  lstItem))
				(setq lEnam (cadr lstItem))
				(setq jLen  (length lEnam) j 0)
				(repeat jLen
					(setq enItem (nth j lEnam))
					(EmbedGroupName sName enItem)
					(setq j (1+ j))
				)
				(setq i (1+ i))
			)
			

			;COPYBASEs
			(command "._COPYBASE" "NON" pOrg g_sSet "")

			;ߍXdataׂč폜
			(setq i 0)
			(repeat iLen
				(setq lstItem (nth i lstGrpEnam))
				(setq sName (car  lstItem))
				(setq lEnam (cadr lstItem))
				(setq jLen  (length lEnam) j 0)
				(repeat jLen
					(setq enItem (nth j lEnam))
					(RemoveXdt enItem g_sAppname)
					(setq j (1+ j))
				)
				(setq i (1+ i))
			)

			;g_sSetJ
			(sk_ssfree g_sSet)
			(setq g_sSet nil)
		))
	))

	;װ֐ؾ
	(ModeReset)
	(setq *error* old_err)
	(*pop-error-mode*)
	(princ)
)


;2. O[v}`ΉPASTECLIPR}h
(defun c:ask_PastGrp ( / )
	;ssXdataO[vč\z
	;߂l = (
	;           (sGroup1 (en11 en12 ...))
	;           (sGroup2 (en21 en22 ...))
	;           ...
	;           (sGroupX (enX1 enX2 ...))
	;         )
	(defun rebuildGroupList (ss / iLen i jLen j lstRet enItem lstGroup sGroup)
		(setq iLen (sslength ss) i 0)
		(repeat iLen
			(setq enItem (ssname ss i))
			(setq lstGroup (GetXdtList enItem g_sAppname))
			(if lstGroup (progn
				(setq jLen (length lstGroup) j 0)
				(repeat jLen
					(setq sGroup (cdr (nth j lstGroup)))
					(setq lstAssc (assoc sGroup lstRet))
					(if (not lstAssc)(progn
						(setq lstNew (cons sGroup (list (list enItem))))
						(setq lstRet (append lstRet (list lstNew)))
					)(progn ;else
						(setq lstNew (cons sGroup (list (append (cadr lstAssc) (list enItem)))))
						(setq lstRet (subst lstNew lstAssc lstRet))
					))
					(setq j (1+ j))
				)

				;ߍ܂ĂXdata폜
				(RemoveXdt enItem g_sAppname)
			))
			(setq i (1+ i))
		)
		lstRet
	)

	;O[v񂩂O[v}`č\z
	;lst = (
	;        (sGroup1 (en11 en12 ...))
	;        (sGroup2 (en21 en22 ...))
	;        ...
	;        (sGroupX (enX1 enX2 ...))
	;      )
	(defun rebuildGroup (lst / iLen i lstItem sGroup lstEnm jLen j enItem)
		(setq iLen (length lst) i 0)
		(repeat iLen
			(setq lstItem (nth i lst))
			(setq sGroup (car lstItem))

			;OȂO[v(ARX)
			(setq sUnmGrp (sk_MakeUnnamedGrp))
			(if sUnmGrp (progn
				(setq lstEnm (cadr lstItem))
				(setq jLen (length lstEnm) j 0)
				(repeat jLen
					(setq enItem (nth j lstEnm))

					;enItemsUnmGrpO[vɓo^(ARX)
					(sk_RegEntityToGrp enItem sUnmGrp)
					(setq j (1+ j))
				)
			))
			(setq i (1+ i))
		)
		(princ)
	)


	; װׯߊ֐̐ݒ
	(setq old_err *error*  *error* SKGrpCmd_err)
	(*push-error-using-command*)
	(ModeSet '("CMDECHO"))
	(setvar "CMDECHO" 0)

	; LastEntityۑ
	(setq eLast (LastEntity))

	;\t(
	(command "._PASTECLIP" pause)

	;LastEntityȍ~ɑ}`
	;(PSTECLIPœ\t}`Q)
	(setq ssPaste (Getss eLast))

	;ssPasteXdataO[vč\z
	(setq lstGrpEnam (rebuildGroupList ssPaste))

	;O[v񂩂O[v}`č\z
	(rebuildGroup lstGrpEnam)

	;װ֐ؾ
	(ModeReset)
	(setq *error* old_err)
	(*pop-error-mode*)
	(princ)
)


;3. O[v}`(lXgΉ)
(defun c:ask_BreakGrp ( / )
	; װׯߊ֐̐ݒ
	(setq old_err *error*  *error* SKGrpCmd_err)
	(*push-error-using-command*)
	(ModeSet '("CMDECHO"))
	(setvar "CMDECHO" 0)

	(setq g_sSet (sk_pssget "\nO[v}`I: "))
	(if g_sSet (progn
		;O[vExplode
		(sk_ExplodeGroupAll g_sSet)

		;g_sSetJ
		(sk_ssfree g_sSet)
		(setq g_sSet nil)
	))

	;װ֐ؾ
	(ModeReset)
	(setq *error* old_err)
	(*pop-error-mode*)
	(princ)
)


;4: O[v쐬
(defun c:ask_makeGrp ( / )
	; װׯߊ֐̐ݒ
	(setq old_err *error*  *error* SKGrpCmd_err)
	(*push-error-using-command*)
	(ModeSet '("CMDECHO"))
	(setvar "CMDECHO" 0)

	(setq g_sSet (sk_pssget "\nO[v}`I: "))
	(if g_sSet (progn
		;O[v
		(command "-GROUP" "C" "*" "" g_sSet "")

		;g_sSetJ
		(sk_ssfree g_sSet)
		(setq g_sSet nil)
	))

	;װ֐ؾ
	(ModeReset)
	(setq *error* old_err)
	(*pop-error-mode*)
	(princ)
)


;5: O[v(O)
(defun c:ask_unGroup ( / )
	; װׯߊ֐̐ݒ
	(setq old_err *error*  *error* SKGrpCmd_err)
	(*push-error-using-command*)

	(ModeSet '("CMDECHO" "PICKSTYLE" "PICKAUTO"))
	(acet-Undo-Begin)
	(setvar "CMDECHO" 0)
	(setvar "PICKSTYLE" 1)
	(setvar "PICKAUTO"  0)

	(setq g_sSet (sk_SingleSsgetWithPrompt "\nO[v}`w: "))

	(if g_sSet (progn
		;O[v(ԊÔ)
		(sk_PeelGroup g_sSet)

		;g_sSetJ
		(sk_ssfree g_sSet)
		(setq g_sSet nil)
	))
	(acet-Undo-End)
	;װ֐ؾ
	(ModeReset)
	(setq *error* old_err)
	(*pop-error-mode*)
	(princ)
)

;6 O[vI/I(PICKSTYLEl̃gOXCb`)
(defun c:ask_GrpSwitch ( / sPrev iCurr)
	;Ol
	(setq sPrev (getenv "SK_PickStylePrevValue"))
	(if (or (not sPrev)(= sPrev ""))(progn
		(setq sPrev "1")
		(setenv "SK_PickStylePrevValue" sPrev)
	))

	;Switch
	(if (= (setq iCurr (getvar "PICKSTYLE")) 0)(progn
		(setvar "PICKSTYLE" (atoi sPrev))
		(prompt (strcat "\nO[vI[h(PICKSTYLE)̒lON<" sPrev ">ł"))
	)(progn ;else
		(setvar "PICKSTYLE" 0)
		(prompt "\nO[vI[h(PICKSTYLE)̒lOFF<0>ł")
		(setenv "SK_PickStylePrevValue" (itoa iCurr))
	))
	(princ)
)

;9 ubN --> O[vϊ
(defun c:ask_BlcToGrp ( / filter )
	; װׯߊ֐̐ݒ
	(setq old_err *error*  *error* SKGrpCmd_err)
	(*push-error-using-command*)
	(ModeSet '("CMDECHO"))
	(setvar "CMDECHO" 0)

	(setq filter '((0 . "INSERT")))
	(setq g_sSet (sk_pSsGetF "\nO[vɕϊubN}`I: " filter))
	(if g_sSet (progn
		;Block --> O[vϊ
		(sk_BlcToGroup g_sSet)

		;g_sSetJ
		(sk_ssfree g_sSet)
		(setq g_sSet nil)
	))

	;װ֐ؾ
	(ModeReset)
	(setq *error* old_err)
	(*pop-error-mode*)
	(princ)
)
